//////////////////////////////////////////////////////////////////////////////////////////////
// Clase para resolver un sistema lineal usando factorizacion LU                            //
//                                                                                          //
// Anlisis y Diseo y Programacin:                                                        //
//                                                                                          //
// Nombre:   Antonio Carrillo Ledesma                                                       //
// E-mail:   acl@www.mmc.igeofcu.unam.mx                                                    //
// Pgina:   http://www.mmc.igeofcu.unam.mx/acl                                             //
//                                                                                          //
//                                                                                          //
// Este programa es software libre. Puede redistribuirlo y/o modificarlo                    //
// bajo los trminos de la Licencia Pblica General de GNU segn es                         //
// publicada por la Free Software Foundation, bien de la versin 2 de                       //
// dicha Licencia o bien (segn su eleccin) de cualquier versin                           //
// posterior.                                                                               //
//                                                                                          //
// Este programa se distribuye con la esperanza de que sea til, pero SIN                   //
// NINGUNA GARANTA, incluso sin la garanta MERCANTIL implcita o sin                      //
// garantizar la CONVENIENCIA PARA UN PROPSITO PARTICULAR. Vase la                        //
// Licencia Pblica General de GNU para ms detalles.                                       //
//                                                                                          //
// Debera haber recibido una copia de la Licencia Pblica General junto                    //
// con este programa. Si no ha sido as, escriba a la Free Software                         //
// Foundation, Inc., en 675 Mass Ave, Cambridge, MA 02139, EEUU.                            //
//                                                                                          //
//                                                                                          //
//////////////////////////////////////////////////////////////////////////////////////////////



#ifndef __ResuelveFactorizacionLU__
#define __ResuelveFactorizacionLU__

#include "ResuelveSistemaLineal.hpp"
#include "MatrizBandDisp.hpp"



/// Clase para resolucin del sistema lineal usando factorizacion LU
/** @author Antonio Carrillo Ledesma
    @date primavera 2009
    @version 1.0.1
    @bug No hay errores conocidos
*/
class ResuelveFactorizacionLU: public ResuelveSistemaLineal
{
protected:

   /// Matriz factorizada
   bool MatrizFactorizada;


public:

   /// Constructor de la clase
   ResuelveFactorizacionLU(void) : ResuelveSistemaLineal()
   {
      X = NULL;
      B = NULL;
      MetodoModificaMatriz = true;
      MetodoNumerico = FACT_LU;
      MatrizFactorizada = false;
   }

   /// Constructor de la clase
   /** @param x Puntero a un Vector, solucin del sistema lineal
       @param b Puntero a un vector, lado derecho del sistema lineal */
   ResuelveFactorizacionLU(Vector *x, Vector *b) : ResuelveSistemaLineal()
   {
      X = x;
      B = b;
      MetodoModificaMatriz = true;
      MetodoNumerico = FACT_LU;
      MatrizFactorizada = false;
   }

   /// Factoriza la matriz A en L y U dejandolas en la misma matriz
   virtual void factoriza(void) = 0;

};

#endif
